//
//  JournalArticle.cpp
//  Assignment4
//
//  Created by 张昊 on 16/11/3.
//  Copyright © 2016年 张昊. All rights reserved.
//

#include "JournalArticle.h"

//JournalArticle
JournalArticle::JournalArticle()
{
    JournalNo = "";
    Publisher = "";
}
JournalArticle::JournalArticle(string content)
{
    vector<string> token;
    
    string::size_type begin = content.find_first_of(";");
    while(begin < content.length())
    {
        token.push_back( content.substr(0, begin) );
        content = content.substr(begin+2, content.length() - begin - 2);
        begin = content.find_first_of(";");
    }

    
    Type = "JA";
    Title = token[0];
    Author = token[1];
    JournalNo = token[2];
    Publisher = token[3];
    Time = stoi(content);
}
JournalArticle::~JournalArticle()
{
    ;
}

void JournalArticle::print()
{
    cout<<"Type: "<<Type<<endl;
    cout<<"Title: "<<Title<<endl;
    cout<<"Author: "<<Author<<endl;
    cout<<"Journal Name: "<<JournalNo<<endl;
    cout<<"Publisher: "<<Publisher<<endl;
    cout<<"Publish Time: "<<Time<<endl;
    cout<<endl;
}
