//
//  Library.cpp
//  Assignment4
//
//  Created by 张昊 on 16/11/3.
//  Copyright © 2016年 张昊. All rights reserved.
//

#include "Library.h"

Library::~Library()
{
    
}
bool less_time(const Document* d1, const Document* d2)
{
    if(d1->Time < d2->Time)
        return true;
    else if(d1->Time > d2->Time)
        return false;
    else
        return (d1->Author < d2->Author);
}

void Library::printByTime()
{
    sort(doc_list.begin(), doc_list.end(), less_time);
    for(auto i = doc_list.begin(); i != doc_list.end(); i++)
    {
        (*i)->print();
    }
}

bool less_author(const Document* d1, const Document* d2)
{
    if(d1->Author < d2->Author)
        return true;
    else if(d1->Author > d2->Author)
        return false;
    else
        return (d1->Time < d2->Time);
}
void Library::printByAuthor()
{
    sort(doc_list.begin(), doc_list.end(), less_author);
    for(auto i = doc_list.begin(); i != doc_list.end(); i++)
    {
        (*i)->print();
    }
}


void Library::queryByTime(int start, int end)
{
    vector<Document *> D1;
    
    /*decltype(doc_list.begin()) index = find_if(doc_list.begin(), doc_list.end(),  [start,end](const Document* d) {return (d->Time >= start && d->Time <= end);});
    while(index != doc_list.end())
    {
        D1.push_back(*index);
        index = find_if(index, doc_list.end(), [start,end](const Document* d){return (d->Time >= start && d->Time <= end);});
    }*/
    
    for(auto i = doc_list.begin(); i < doc_list.end(); i++)
    {
        if( (*i)->Time >= start && (*i)->Time <=end)
            D1.push_back(*i);
    }
    
    sort(D1.begin(), D1.end(), less_time);
    for(auto i = D1.begin(); i != D1.end(); i++)
    {
        (*i)->print();
    }
}

void Library::queryByAuthor(string a)
{
    vector<Document *> D2;
    /*auto index = find_if(doc_list.begin(), doc_list.end(), [a](const Document* d)
    {
        auto index = search(d->Author.begin(), d->Author.end(), a.begin(), a.end());
        if(index != d->Author.end())
            return true;
        else
            return false;
    });
    while(index != doc_list.end())
    {
        D2.push_back(*index);
        index = find_if(index, doc_list.end(),[a](const Document* d)
        {
            auto index = search(d->Author.begin(), d->Author.end(), a.begin(), a.end());
            if(index != d->Author.end())
                return true;
            else
                return false;
        });
    }*/
    for(auto i = doc_list.begin(); i < doc_list.end(); i++)
    {
        if( search( (*i)->Author.begin(), (*i)->Author.end(), a.begin(),a.end()) != (*i)->Author.end() ||(search( (*i)->Author.begin(), (*i)->Author.end(), a.begin(),a.end()) != (*i)->Author.end()&&(*i)->Author.size() != a.size()))
            D2.push_back(*i);
    }
    
    sort(D2.begin(), D2.end(), less_time);
    for(auto i = D2.begin(); i != D2.end(); i++)
    {
        (*i)->print();
    }
}







